from flask import current_app, request, jsonify
from apps.atlas import api_atlas
from apps.util import login_required
from apps.utils.response_code import RET
from apps.models import *
from apps.utils.neo4j_conn import conn_neo4j,neo4j_dict
from apps import redis_store
import json

graph = conn_neo4j()

'''行业名转换ptp字典两个  neo4j_dict  line 164/177'''

def deleteDuplicate(li):
    '''
    列表[字典]去重
    :param li:
    :return:
    '''
    temp_list = list(set([str(i) for i in li]))
    li = [eval(i) for i in temp_list]
    return li


def find_up(inid, name_query, relation, district):
    if relation == "中游行业":
        relation_c = "下位产品"
    else:
        relation_c = relation

    sql = "match (n) -[r:`{}`]->(m) WHERE n.name='{}' return n.name,r.type,m.name".format(relation_c, name_query)
    res = graph.run(sql).data()
    cnums = Company.query.filter_by(stream="{}".format(relation[:2]), c_type=inid).count()

    data = {"clickable": False,
            "node": "{}".format(relation[:2]),
            "level": 1,
            "subNodeList": [],
            "count": cnums
            }
    past = list()
    for it in res:
        productName = it["m.name"]
        if productName in past:
            continue
        past.append(productName)
        if district:
            erjicount = Company.query.filter_by(province="山西省", city="太原市", district=district).filter(
                Company.product_all.like("%{}%".format(productName))).count()
        else:
            erjicount = Company.query.filter_by(province="山西省", city="太原市").filter(
                Company.product_all.like("%{}%".format(productName))).count()
        node = {"clickable": True,
                "node": "{}".format(productName),
                "level": 2,
                "count": erjicount,
                "subNodeList": []
                }
        sql_02 = "match (n) -[r]->(m) WHERE n.name='{}' return n.name,r.type,m.name".format(productName)
        result = graph.run(sql_02).data()

        for item in result:
            productName = item["m.name"]
            if district:
                count = Company.query.filter_by(province="山西省", city="太原市", district=district).filter(
                    Company.product_all.like("%{}%".format(productName))).count()
            else:
                count = Company.query.filter_by(province="山西省", city="太原市").filter(
                    Company.product_all.like("%{}%".format(productName))).count()
            # erjicount += count
            node["subNodeList"].append({"clickable": True,
                                        "node": "{}".format(productName),
                                        "level": 3,
                                        "count": count,
                                        "subNodeList": []
                                        })
        # node["count"] = erjicount # 累计值
        data["subNodeList"].append(node)

    return data


def find_up_thr(inid, name_query, relation, district):
    if relation == "中游行业":
        relation_c = "下位产品"
    else:
        relation_c = relation

    cnums = Company.query.filter_by(stream="{}".format(relation[:2]), c_type=inid).count()  # 上中下游企业数目
    # 零级，上中下三游
    data = {"clickable": False,
            "node": "{}".format(relation[:2]),
            "level": 1,
            "subNodeList": [],
            "count": cnums
            }
    sql_01 = "match (n) -[r:`{}`]->(m) WHERE n.name='{}' return n.name,r.type,m.name".format(relation_c, name_query)
    res_zero = graph.run(sql_01).data()
    res_one = list(set([i["m.name"] for i in list(res_zero)]))  # 不重复的一级节点
    for it in res_one:  # 一级节点
        pname_one = it
        # 获取当前子节点数量
        if district:
            erjicount = Company.query.filter_by(c_type=inid, province="山西省", city="太原市", district=district).filter(
                Company.product_all.like("%{}%".format(pname_one))).count()
        else:
            erjicount = Company.query.filter_by(c_type=inid, province="山西省", city="太原市").filter(
                Company.product_all.like("%{}%".format(pname_one))).count()
        # 一级
        node_one = {"clickable": True,
                    "node": "{}".format(pname_one),
                    "level": 2,
                    "count": erjicount,
                    "subNodeList": []
                    }
        sql_02 = "match (n) -[r]->(m) WHERE n.name='{}' return n.name,r.type,m.name".format(pname_one)
        result = graph.run(sql_02).data()
        result = list(set([i["m.name"] for i in list(result)]))  # 不重复的二级节点
        for item in result:
            pname_two = item
            # 二级子节点数量
            if district:
                count2 = Company.query.filter_by(c_type=inid, province="山西省", city="太原市", district=district).filter(
                    Company.product_all.like("%{}%".format(pname_two))).count()
            else:
                count2 = Company.query.filter_by(c_type=inid, province="山西省", city="太原市").filter(
                    Company.product_all.like("%{}%".format(pname_two))).count()
            # 二级
            node_two = {"clickable": True,
                        "node": "{}".format(pname_two),
                        "level": 3,
                        "count": count2,
                        "subNodeList": []
                        }
            sql_03 = "match (n) -[r]->(m) WHERE n.name='{}' return n.name,r.type,m.name".format(pname_two)
            result3 = graph.run(sql_03).data()
            result3 = list(set([i["m.name"] for i in list(result3)]))  # 不重复的三级节点
            for itm in result3:
                pname_thr = itm
                # 二级子节点数量
                if district:
                    count3 = Company.query.filter_by(c_type=inid, province="山西省", city="太原市", district=district).filter(
                        Company.product_all.like("%{}%".format(pname_thr))).count()
                else:
                    count3 = Company.query.filter_by(c_type=inid, province="山西省", city="太原市").filter(
                        Company.product_all.like("%{}%".format(pname_thr))).count()
                # 三级
                node_thr = {"clickable": True,
                            "node": "{}".format(pname_thr),
                            "level": 4,
                            "count": count3,
                            "subNodeList": []
                            }
                node_two["subNodeList"].append(node_thr)
            node_one["subNodeList"].append(node_two)
        data["subNodeList"].append(node_one)

    return data


# 行业产品公司数量(链图,根据地理位置)
@api_atlas.route('/industry/chain', methods=['POST'])
# @login_required
def industry_chain():
    '''
    行业id->行业链标题-》上中下游-》查询数值
    :return:
    '''
    req_dict = request.get_json()
    inid = req_dict.get("inid")  # 二级行业id（二级行业显示链图）
    district = req_dict.get("district")  # 区县

    # 校验参数完整性
    if not all([inid]):
        return jsonify(code=RET.PARAMERR, msg="参数不完整")

    try:
        name_query = "ty" + str(inid) + str(district)
        if redis_store.get(name_query) is not None:
            data = json.loads(redis_store.get(name_query))
            return jsonify(code=RET.OK, msg="获取成功", data=data)

        # 行业使用名
        industryName = Industry.query.filter_by(nid=inid).first().oname
        ptp = neo4j_dict()
        if industryName in ptp:
            industryName = ptp[industryName]
        # print(industryName)
        result = {
            "industryChain": industryName,
            "nodeList": [find_up_thr(inid, industryName, "上游行业", district),
                         find_up_thr(inid, industryName, "中游行业", district),
                         find_up_thr(inid, industryName, "下游行业", district)]
        }
        # redis缓存
        redis_store.set(name_query, json.dumps(result))
        redis_store.expire(name_query, 30 * 24 * 3600)
        print("redis")
    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="数据异常")
    return jsonify(code=RET.OK, msg="获取成功", data=result)


# 太原市一级行业下的两级图谱展示
@api_atlas.route("/industry/nevigate", methods=["POST"])
# @login_required
def indu_nevigate():
    req_dict = request.get_json()
    inid = req_dict.get("inid")  # 行业id,不为0
    cate = req_dict.get("cate")  # 行业等级,（高端设备等五个为"1",子行业为"2"）
    # print(inid, cate)

    if cate != "1":
        return jsonify(code=RET.DATAERR, msg="参数异常")
    try:
        indu = Industry.query.filter_by(nid=inid, statu=1).first()
        if not indu:
            return jsonify(code=RET.DATAERR, msg="参数异常")
        name = indu.name  # 显示名
        # childs = Industry.query.filter_by(fid=indu.nid, statu=1).all()
        childs = Industry.query.filter_by(fid=indu.nid).all()  # 全部展示
        nodes = []
        links = []

        for child in childs:
            count = Company.query.filter_by(c_type=child.nid).count()  # 当前行业在数据中的频
            if count==0:
                continue
            nodes.append(
                {"id": child.nid, "name": "{}".format(child.name + "({})".format(count)), "count": count,
                 "nodeShape": 0, "color": "#43a2f1", "cate": "2"})
            links.append({"from": '{}'.format(indu.nid), "to": '{}'.format(child.nid), "text": ''})
            # id += 1

        count = Company.query.filter_by(f_type=indu.nid).count()
        nodes.append({"id": "{}".format(indu.nid), "name": "{}".format(name), "count": count, "cate": "1"})
        result = {'nodes': deleteDuplicate(nodes), 'links': deleteDuplicate(links), "rootId": '1'}

    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="数据异常")
    return jsonify(code=RET.OK, msg="获取成功", data=result)


# 点击二级导航的行业产业链原点()
@api_atlas.route('/ej/zero', methods=['POST'])
# @login_required
def zero():
    req_dict = request.get_json()
    inid = req_dict.get("inid")  # 行业id
    cate = req_dict.get("cate")  # 行业等级,（高端设备等五个为"1",子行业为"2"）
    if cate != "2":
        return jsonify(code=RET.DATAERR, msg="参数错误")
    center = Industry.query.filter_by(nid=inid).first()
    pname = center.oname  # 获取可查询真名
    ptp = neo4j_dict()

    product = pname
    if pname in ptp:
        product = ptp[pname]

    sql = "match (n) -[r:`下游行业`]->(m) WHERE n.name='{}' return id(n) as id,n.name as name UNION " \
          "match (n) -[r:`上游行业`]->(m) WHERE n.name='{}' return id(n) as id,n.name as name UNION " \
          "match (n) -[r:`下位产品`]->(m) WHERE n.name='{}' return id(n) as id,n.name as name ".format(product,
                                                                                                   product,
                                                                                                   product)
    res = graph.run(sql).data()
    try:
        result = {
            "rootId": '{}'.format(res[0]["id"]),
            "nodes": [{"id": "{}".format(res[0]["id"]), "name": "{}↓".format(product)}],
            "links": []  # {"from": '1', "to": '{}'.format(res[0]["id"]), "text": ''}
        }
    except:
        result = {
            "rootId": '{}'.format(res[0]["id"]),
            "nodes": [{"id": "{}".format(res[0]["id"]), "name": "{}↓".format(product)}],
            "links": []  # {"from": '1', "to": '{}'.format(res[0]["id"]), "text": ''}
        }
    return jsonify(code=RET.OK, msg="获取成功", data=result)


def haveNext(name):
    '''
    判断是否有下一级子节点
    :param name: name of node
    :return:
    '''
    sql = "match (n)-[r]->(m) WHERE n.name='{}' return r.type limit 1".format(name)
    res = graph.run(sql).data()
    if len(res) >= 1:
        return True
    else:
        return False


def find_next(name, _id):
    '''
    查找下一级节点
    :param name:
    :param _id: 出发节点id
    :return:
    '''
    result = {'nodes': [], 'links': []}

    sql = "match (n) -[r:`下游行业`]->(m) WHERE n.name='{}' return id(n),id(m),n.name,r.type,m.name  UNION " \
          "match (n) -[r:`上游行业`]->(m) WHERE n.name='{}' return id(n),id(m),n.name,r.type,m.name  UNION " \
          "match (n) -[r:`下位产品`]->(m) WHERE n.name='{}' return id(n),id(m),n.name,r.type,m.name ".format(name, name,
                                                                                                         name)
    res = graph.run(sql).data()
    # print("查询结果：", res)
    for i in res:
        if haveNext(i["m.name"]):
            result["nodes"].append({"id": "{}".format(i["id(m)"]), "name": "{}↓".format(i["m.name"])})
            result["links"].append(
                {"from": "{}".format(_id), "to": "{}".format(i["id(m)"]), "text": "{}".format(i["r.type"])})
        else:
            result["nodes"].append({"id": "{}".format(i["id(m)"]), "name": "{}".format(i["m.name"])})
            result["links"].append(
                {"from": "{}".format(_id), "to": "{}".format(i["id(m)"]), "text": "{}".format(i["r.type"])})
    # for i in res:
    #     if haveNext(i["m.name"]):
    #         result["antity"].append({'name': '{}'.format(i["m.name"]), 'name_query': '{}'.format(
    #             i["m.name"])})
    #         result["relation"].append(
    #             {'source': '{}'.format(i["n.name"]), 'target': '{}↓'.format(i["m.name"]),
    #              'name': '{}'.format(i["r.type"])})
    #     else:
    #         result["antity"].append({'name': '{}'.format(i["m.name"]), 'name_query': '{}'.format(
    #             i["m.name"])})
    #         result["relation"].append(
    #             {'source': '{}'.format(i["n.name"]), 'target': '{}'.format(i["m.name"]),
    #              'name': '{}'.format(i["r.type"])})
    # return result
    return result


# 点击二级导航下行业产业链气泡出现下一级
@api_atlas.route('/ej/next', methods=['POST'])
# @login_required
def next():
    req_dict = request.get_json()
    name = req_dict.get("name")  # 获取节点名称(不带下箭头)
    # name_query = req_dict.get("name_query")  # 获取查询节点名称
    _id = req_dict.get("id")  # 节点id

    # 校验参数完整性
    if not all([name]):
        return jsonify(code=RET.PARAMERR, msg="参数不完整")
    try:
        result = find_next(name, _id)
        final_result = dict()
        # 列表字典去重
        nodes = deleteDuplicate(result["nodes"])
        links = deleteDuplicate(result["links"])

        final_result["nodes"] = nodes
        final_result["links"] = links
        return jsonify(code=RET.OK, msg="获取成功", data=final_result)
    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="数据异常", data={})
